scala.tools.nsc.transform.patmat

# MatchApproximation

###
Related Doc: package patmat

#### trait MatchApproximation extends TreeAndTypeAnalysis with ScalaLogic with MatchTreeMaking

Source
  MatchAnalysis.scala

Linear Supertypes
MatchTreeMaking, MatchCodeGen, ScalaLogic, Logic, Interface, TreeDSL, TreeAndTypeAnalysis, Debugging, AnyRef, Any
Known Subclasses
MatchAnalysis, MatchOptimization, PatternMatching, patmat
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. MatchApproximation
2. MatchTreeMaking
3. MatchCodeGen
4. ScalaLogic
5. Logic
6. Interface
7. TreeDSL
8. TreeAndTypeAnalysis
9. Debugging
10. AnyRef
11. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Type Members

1. #### trait CheckableTreeAndTypeAnalysis extends AnyRef

   Definition Classes
     TreeAndTypeAnalysis

2. #### trait CodegenCore extends MatchMonadInterface

   Definition Classes
     MatchCodeGen

3. #### trait MatchApproximator extends TreeMakers with TreesAndTypesDomain

   Represent a match as a formula in propositional logic that encodes whether the match matches (abstractly: we only consider types)

4. #### trait MatchMonadInterface extends AnyRef

   Interface with user-defined match monad? if there's a `__match` in scope, we use this as the match strategy, assuming it conforms to MatchStrategy as defined below:

   Interface with user-defined match monad? if there's a `__match` in scope, we use this as the match strategy, assuming it conforms to MatchStrategy as defined below:

       type Matcher[P[_], M[+_], A] = {
         def flatMap[B](f: P[A] => M[B]): M[B]
         def orElse[B >: A](alternative: => M[B]): M[B]
       }

       abstract class MatchStrategy[P[_], M[+_]] {
         // runs the matcher on the given input
         def runOrElse[T, U](in: P[T])(matcher: P[T] => M[U]): P[U]

         def zero: M[Nothing]
         def one[T](x: P[T]): M[T]
         def guard[T](cond: P[Boolean], then: => P[T]): M[T]
       }

   P and M are derived from one's signature (`def one[T](x: P[T]): M[T]`)

   if no `__match` is found, we assume the following implementation (and generate optimized code accordingly)

       object __match extends MatchStrategy[({type Id[x] = x})#Id, Option] {
         def zero = None
         def one[T](x: T) = Some(x)
         // NOTE: guard's return type must be of the shape M[T], where M is the monad in which the pattern match should be interpreted
         def guard[T](cond: Boolean, then: => T): Option[T] = if(cond) Some(then) else None
         def runOrElse[T, U](x: T)(f: T => Option[U]): U = f(x) getOrElse (throw new MatchError(x))
       }

   Definition Classes
     Interface

5. #### trait OptimizedCodegen extends CodegenCore with TypedSubstitution with MatchMonadInterface

   Definition Classes
     MatchCodeGen

6. #### trait PropositionalLogic extends AnyRef

   Definition Classes
     Logic

7. #### trait PureCodegen extends CodegenCore with PureMatchMonadInterface

   Definition Classes
     MatchCodeGen

8. #### trait PureMatchMonadInterface extends MatchMonadInterface

   Definition Classes
     MatchCodeGen

9. #### final case class Suppression(suppressExhaustive: Boolean, suppressUnreachable: Boolean) extends Product with Serializable

   Definition Classes
     MatchTreeMaking

10. #### trait TreeMakers extends TypedSubstitution with CodegenCore

    Definition Classes
      MatchTreeMaking

11. #### trait TreesAndTypesDomain extends PropositionalLogic with CheckableTreeAndTypeAnalysis

    Definition Classes
      ScalaLogic

12. #### trait TypedSubstitution extends MatchMonadInterface

    Definition Classes
      Interface

### Abstract Value Members

1. #### abstract val global: Global

   Definition Classes
     TreeDSL

### Concrete Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from MatchApproximation to any2stringadd[MatchApproximation] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (MatchApproximation, B)

   Implicit information
     This member is added by an implicit conversion from MatchApproximation to ArrowAssoc[MatchApproximation] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### object CODE

   Definition Classes
     TreeDSL

7. #### object Suppression extends Serializable

   Definition Classes
     MatchTreeMaking

8. #### def alignAcrossRows(xss: List[List[Any]], sep: String, lineSep: String = "\n"): String

   Definition Classes
     Logic

9. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

10. #### def binderTypeImpliedByPattern(pat: Global.Tree, pt: Global.Type, binder: Global.Symbol): Global.Type

    Compute the type T implied for a value `v` matched by a pattern `pat` (with expected type `pt`).

    Compute the type T implied for a value `v` matched by a pattern `pat` (with expected type `pt`).

    Usually, this is the pattern's type because pattern matching implies instance-of checks.

    However, Stable Identifier and Literal patterns are matched using `==`, which does not imply a type for the binder that binds the matched value.

    See SI-1503, SI-5024: don't cast binders to types we're not sure they have

    TODO: update spec as follows (deviation between `**`):

    A pattern binder x@p consists of a pattern variable x and a pattern p. The type of the variable x is the static type T **IMPLIED BY** the pattern p. This pattern matches any value v matched by the pattern p **Deleted: , provided the run-time type of v is also an instance of T, ** and it binds the variable name to that value.

    Addition: A pattern `p` _implies_ a type `T` if the pattern matches only values of the type `T`.

    Definition Classes
      TreeAndTypeAnalysis

11. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @HotSpotIntrinsicCandidate() @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

12. #### final def dealiasWiden(tp: Global.Type): Global.Type

    Attributes
      protected
    Definition Classes
      Interface

13. #### object debug

    Definition Classes
      Debugging

14. #### def ensuring(cond: (MatchApproximation) ⇒ Boolean, msg: ⇒ Any): MatchApproximation

    Implicit information
      This member is added by an implicit conversion from MatchApproximation to Ensuring[MatchApproximation] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

15. #### def ensuring(cond: (MatchApproximation) ⇒ Boolean): MatchApproximation

    Implicit information
      This member is added by an implicit conversion from MatchApproximation to Ensuring[MatchApproximation] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

16. #### def ensuring(cond: Boolean, msg: ⇒ Any): MatchApproximation

    Implicit information
      This member is added by an implicit conversion from MatchApproximation to Ensuring[MatchApproximation] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

17. #### def ensuring(cond: Boolean): MatchApproximation

    Implicit information
      This member is added by an implicit conversion from MatchApproximation to Ensuring[MatchApproximation] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

18. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

19. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

20. #### def equivalentTree(a: Global.Tree, b: Global.Tree): Boolean

    Definition Classes
      TreeAndTypeAnalysis

21. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from MatchApproximation to StringFormat[MatchApproximation] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

22. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Annotations
      @HotSpotIntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

23. #### final def hasStableSymbol(p: Global.Tree): Boolean

    Attributes
      protected
    Definition Classes
      Interface

24. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any
    Annotations
      @HotSpotIntrinsicCandidate()

25. #### def instanceOfTpImplies(tp: Global.Type, tpImplied: Global.Type): Boolean

    Definition Classes
      TreeAndTypeAnalysis

26. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

27. #### final def mkFALSE: Global.Literal

    Attributes
      protected
    Definition Classes
      Interface

28. #### final def mkTRUE: Global.Literal

    Attributes
      protected
    Definition Classes
      Interface

29. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

30. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @HotSpotIntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

31. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @HotSpotIntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

32. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

33. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

34. #### object vpmName

    Definition Classes
      Interface

35. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

36. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

37. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

38. #### def →[B](y: B): (MatchApproximation, B)

    Implicit information
      This member is added by an implicit conversion from MatchApproximation to ArrowAssoc[MatchApproximation] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Deprecated Value Members

1. #### def finalize(): Unit

   Called by the garbage collector on the receiver object when there are no more references to the object.

   Called by the garbage collector on the receiver object when there are no more references to the object.

   The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @Deprecated @deprecated @throws( classOf[java.lang.Throwable] )
   Deprecated

     (Since version ) see corresponding Javadoc for more information.

   Note

     not specified by SLS as a member of AnyRef

### Inherited from MatchTreeMaking

### Inherited from MatchCodeGen

### Inherited from ScalaLogic

### Inherited from Logic

### Inherited from Interface

### Inherited from TreeDSL

### Inherited from TreeAndTypeAnalysis

### Inherited from Debugging

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from MatchApproximation to any2stringadd[MatchApproximation]

### Inherited by implicit conversion StringFormat from MatchApproximation to StringFormat[MatchApproximation]

### Inherited by implicit conversion Ensuring from MatchApproximation to Ensuring[MatchApproximation]

### Inherited by implicit conversion ArrowAssoc from MatchApproximation to ArrowAssoc[MatchApproximation]

### Ungrouped